//CHUAFONC_f Scicos Chua non-linear function block
//Classical interface function ver1.0 - scilab-2.7
//18 novembre 2003 - IRCOM GROUP - Author : A.Layec
function [x,y,typ]=CHUAFONC_f(job,arg1,arg2)
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)
case 'set' then
   x=arg1;
   graphics=arg1.graphics;model=arg1.model;
   exprs=graphics.exprs;

   while %t do
    [ok,m0,m1,exprs]=getvalue('Chua non-linear function',...
    ['m0';'m1'],list('vec',-1,'vec',-1),exprs);

     if ~ok then break,end;
     Nu=size(m0,'*')

     if (size(m0)==size(m1)) then
       if ok then
          graphics.exprs=exprs
          model.in=Nu
          model.out=Nu
          model.rpar=[m0(:);m1(:)]
          x.graphics=graphics; x.model=model
          break
       end
     else
        message('All parameters must have the same size');
     end
   end

case 'define' then

  Nu=1
  m0=-8/7
  m1=-5/7

  model=scicos_model()
  model.sim=list('chuafonc',2)
  model.in=Nu
  model.out=Nu
  model.evtin=[]
  model.evtout=[]
  model.dstate=[]
  model.rpar=[m0;m1]
  model.ipar=[]
  model.blocktype='d'
  model.firing=[]
  model.dep_ut=[%t %f]

  gr_i=['thick=xget(''thickness'')'
        'pat=xget(''pattern'')'
        'fnt=xget(''font'')'
        'xset(''thickness'',2)'
        'xpoly(orig(1)+[0.071;0.369;0.638;0.938]*sz(1),orig(2)+[0.836;0.717;0.289;0.148]*sz(2),"'lines"')'
        'txt=''CHUAFUNC'';'
        'style=5;'
        'rectstr=stringbox(txt,orig(1),orig(2),0,style,1);'
        'w=(rectstr(1,3)-rectstr(1,2))*%zoom;'
        'h=(rectstr(2,2)-rectstr(2,4))*%zoom;'
        'xstringb(orig(1)+sz(1)/2-w/2,orig(2)-h-4,txt,w,h,''fill'');'
        'e=gce();'
        'e.font_style=style;'
        'xset(''thickness'',thick)'
        'xset(''pattern'',pat)'
        'xset(''font'',fnt(1),fnt(2))'
       ]
  exprs=[string('-8/7'),string('-5/7')];
  x=standard_define([2 2],model,exprs,gr_i)
//   x.graphics.id="CHUAFUNC"
end
endfunction