/* Modnumlib Scicos interfacing function
 * Copyright (C) 2009-2011 Alan Layec
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
/* teb Scicos block
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7
 * 28 janvier 2004 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "machine.h"

/* Cette fonction est un compteur qui incrmente par pas de 1 
 * chaque fois que u<>0.
 *
 * Entre rgulire : u : Signal d'entre
 * Sortie rgulire : y : signal de sortie
 * Entre vnementielle : nant
 * Sortie vnementielle : nant
 *
 * Paramtres entier :     insz[0] : taille du vecteur en entre
 *
 * tat discret      :     z[0] : compteur
 */

/*prototype*/
void teb(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
         ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
  /*dclaration des variables*/
  double *y;
  double *u;
  int nu,i;

  /*rcupration des adresses des ports rguliers*/
  y=(double *)outptr[0];
  u=(double *)inptr[0];

  /*rcupration du nombre d'chantillon*/
  nu=insz[0];

  /*Le flag 1 calcul z et place la valeur de z dans y*/
  if(*flag==1)
    {
      for(i=0;i<nu;i++)
        {
         if(u[i]!=0) z[0]++;
        }
      y[0]=z[0];
    }
}
