//theorical rayleigh distribution
function y=dist_rayl(x,sig)
  x=x(:);
  y=[];
  for i=1:size(x,1)
    y(i)=(x(i)*exp(-(x(i)^2)/(2*(sig^2))))/(sig^2);
  end
endfunction


h=scf(1);clf(1);
drawlater();
sig=[0.5 1 2 3 4];
x=0:1e-2:10;

for i=1:size(sig,2)
  //rayleigh number generator
  y=genrayl(sig(i),0.5e6);
  histplot(50,y);
  h.children.children(1).children.foreground=i+1;

  y=dist_rayl(x,sig(i));
  plot2d(x,y)
  h.children.children(1).children.foreground=i+1;
  h.children.children(1).children.thickness=2;
end
h.children.tight_limits="on";
h.children.data_bounds(2,1)=10;
h.children.data_bounds(2,2)=1.25;
legends(["sig=0.5" "sig=1" "sig=2" "sig=3" "sig=4"],...
        [2 3 4 5 6],"ur");
drawnow;

