// F   : fonction de transfert du filtre de boucle
//       (systme linaire en %s)
// kv  : sensibilit [Hz/v]
// Icp : courant max de la pompe de charge [A]
// N   : facteur de division du diviseur de retour
function B=closedloop(F,kv,Icp,N)
 Kv  = kv*(2*%pi);
 Kcp = Icp/(2*%pi);
 G  = syslin('c',Kv*Kcp*F.num,(%s*F.den));
 GH = syslin('c',Kv*Kcp*F.num,(N*%s*F.den));
 B  = syslin('c', G /(1 + GH));
endfunction

